/// <summary>
/// RT-edge GbWVXeRei
/// 
///		eC@\{ egretain.c
/// 
///	Base programming K.Machii
///
/// Copyright(C) 2025 Micronet Co. All Rights Reserved.
/// 
/// </summary>
#include <stdint.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <stdio.h>
#include "egapi.h"
#include <rt.h>
#include "EgRetain.h"


BOOL Open(void)
{
	// ReiŗL̏
	Container_Init();
	RetainFile_Init();
	return TRUE;
}

BOOL Close(void)
{
	// ReȉI
	Container_Finish();
	return TRUE;
}

BOOL Read(void)
{
	int			count = egTagRefs_IN_Count;
	EGTAGREF*	tags = egTagRefs_IN;
	int32_t		result;
	int			lp1;
	void*		pBuf;
	uint16_t	sizeBuf;
	FILE*		retain;
	size_t		fileresult;
	char*		filepath;

	// eCt@CJ܂
	filepath = RetainFile_GetPath();
	retain = fopen(filepath, "rb");
	if (retain == NULL)
		return FALSE;

	// t@C`̃nbVR[hǍ(Ƀ`FbNςȂ̂œǂݎ̂Ă܂j
	DWORD		hashcode;
	fileresult = fread(&hashcode, sizeof(hashcode), 1, retain);

	for (lp1 = 0; lp1 < count; lp1++, tags++)
	{
		// f[^TCYZo܂
		result = EgTagGetProperty(tags->Name, "Size", &sizeBuf, sizeof(sizeBuf));
		if (result != EDGE_SUCCESS)
			continue;
		if (sizeBuf <= 0)
			continue;

		// f[^TCỸobt@pӂ܂
		pBuf = malloc(sizeBuf);
		if (pBuf == NULL)
			continue;

		// eCt@Cǂݍ݂܂
		fileresult = fread(pBuf, sizeBuf, 1, retain);
		if (fileresult == 0)
			continue;

		// GbW^Oɏ݂܂
		switch (tags->Type)
		{
		case EgVtSegment:
			result = EgTagWriteSegmentByEntry(tags->Entry, 0, pBuf, sizeBuf);
			break;
		case EgVtString:
			result = EgTagWriteString(tags->Name, pBuf);
			break;
		default:
			result = EgTagWriteByEntry(tags->Entry, pBuf, sizeBuf);
			break;
		}

		// obt@J܂
		free(pBuf);

		// G[͖Čp܂
		if (result != EDGE_SUCCESS)
			;
	}

	// eCt@C܂
	fclose(retain);

	return TRUE;
}

BOOL Write(void)
{
	int			count = egTagRefs_IN_Count;
	EGTAGREF*	tags = egTagRefs_IN;
	int32_t		result;
	int			lp1;
	void*		pBuf;
	uint16_t	sizeBuf;
	FILE*		retain;
	size_t		fileresult;
	char*		filepath;

	// eCt@C̃obNAbv(UseBackup=TRUE)
	BOOL		dobackup;
	dobackup = Property_Usebackup_Get();
	if (dobackup)
		RetainFile_BackupSwap();

	// eCt@CJ܂
	filepath = RetainFile_GetPath();

	retain = fopen(filepath, "wb");
	if (retain == NULL)
		return FALSE;

	// t@C`ɃnbVR[h݂܂
	DWORD		hashcode;
	hashcode = RetainFile_HashCalc();

	fileresult = fwrite(&hashcode, sizeof(hashcode), 1, retain);

	// t@CseekʒunbVR[hړ܂
	if (fseek(retain, sizeof(hashcode), SEEK_SET) != 0)
	{
		Container_Log$(ServiceRealName, EG_LOG_ERR, "Hashfile seek point set err.");
		fclose(retain);
		return false;
	}

	for (lp1 = 0; lp1 < count; lp1++, tags++)
	{
		// f[^TCYZo܂
		result = EgTagGetProperty(tags->Name, "Size", &sizeBuf, sizeof(sizeBuf));
		if (result != EDGE_SUCCESS)
			continue;
		if (sizeBuf <= 0)
			continue;

		// f[^TCỸobt@pӂ܂
		pBuf = malloc(sizeBuf);
		if (pBuf == NULL)
			continue;

		// GbW^Oǂݍ݂܂
		switch (tags->Type)
		{
		case EgVtSegment:
			result = EgTagReadSegmentByEntry(tags->Entry, 0, pBuf, sizeBuf);
			break;
		case EgVtString:
			result = EgTagReadString(tags->Name, pBuf ,sizeBuf);
			break;
		default:
			result = EgTagReadByEntry(tags->Entry, pBuf, sizeBuf);
			break;
		}

		// eCt@Cɏ݂܂
		fileresult = fwrite(pBuf, sizeBuf, 1, retain);
		if (fileresult == 0)
			continue;

		// obt@J܂
		free(pBuf);

		// G[͖Čp܂
		if (result != EDGE_SUCCESS)
			;
	}

	// eCt@C܂
	fclose(retain);

	return TRUE;
}

/// <summary>
/// C
/// </summary>
/// <param name="argc"></param>
/// <param name="argv"></param>
/// <returns></returns>
int main(int argc, char* argv[])
{
	// W[擾܂
	Container_SetModuleName(argv[0]);

	// T[rX܂
	Open();

	// AutoRun = TRUEȂJn܂
	if (Property_Get_Autorun() == TRUE)
		Indicate_Run(TRUE);

	// vZXCxg҂
	ExitEvent_Wait();

	// 
	Close();
	return 0;
}

