///
/// Copyright(C) 2025 Micronet Co. All Rights Reserved.
/// 
#pragma once

#define		PRI_DEF_BASE				160
#define		PRI_TRIG			0
#define		PRI_NOTIFY			1
#define		PRI_MAIN			2
#define		STACK_NOTIFY		4096
#define		STACK_TRIG			4096

#define		INTERVAL_DEF		100
#define		OUTPATH_DEF			"C:\\RT-edge\\"

#define		CATALOG_PROC			"EgRetain"			// Rei
#define		FILENAME_RETAIN			"EgRetain.bin"		// eCt@C
#define		FILENAME_BACKUP			"EgRetain.$$$"		// eCobNAbvt@C

#define		CATALOG_MAIN			"Main"
#define		CATALOG_EXITEVENT		"Exit"
#define		CATALOG_TRIG			"Trig"
#define		CATALOG_NOTYFY		"Notify"

/// <summary>
/// ReiŎgp^O`̃e[u^
/// </summary>
struct CONTAINER_TAGS
{
	char*				name;				// GbW^O
	enum egTagDataType	type;				// f[^^
	union {									// 
		DWORD				defaultval;		// l(1)
		void*				defaultstr;		// l(2) ̏ꍇ(DWORD)ŃLXgĂ
	};										// 
	BOOL				create;				// TRUE = GbW^O݂Ȃ܂
	void(*function)(struct CONTAINER_TAGS*);	// vpeBݒߏ֐
	char*				source;				// \[X
	char*				comment;			// Rg
	void*				index;				// GbW^ÕCebNXۊǗp
};

// O[oϐ
static DWORD hashcode;	// EgRetain.xmlɒ`ꂽTagRefZonbVli[܂

// egretain.c
extern BOOL Open(void);
extern BOOL Close(void);
extern BOOL Read(void);
extern BOOL Write(void);

// retainfile.c
extern void RetainFile_Init(void);
extern char* RetainFile_GetPath(void);
extern void RetainFile_Remove(void);
extern DWORD RetainFile_HashRead(void);
extern DWORD RetainFile_HashCalc(void);
extern char* RetainFile_BackupGetPath(void);
extern void RetainFile_BackupSwap(void);
// EgRetainŗL
extern void Indicate_SaveCount(void);
extern void Indicate_LoadCount(void);

// trigger.c
extern BOOL Trigger_Init(void);

// property.c
extern void Property_Process_Autorun(struct CONTAINER_TAGS* my);
extern void Property_Process_Priority(struct CONTAINER_TAGS* my);
extern void Property_Process_Interval(struct CONTAINER_TAGS* my);
extern void Property_Process_Backup(struct CONTAINER_TAGS* my);
extern void Property_Process_Outpath(struct CONTAINER_TAGS* my);
extern BOOL Property_Init(void);
extern BOOL Property_Get_Autorun(void);
extern uint32_t Property_Get_Priority(void);
extern uint32_t Property_Get_Interval(void);
extern BOOL Property_Usebackup_Get(void);
extern char* Property_Outpath_Get(void);

// indicate.c
extern BOOL Indicate_Init(void);
extern void Indicate_Status(BYTE statuscode);
extern void Indicate_Error(BOOL error);
extern void Indicate_Run(BOOL running);
extern void Indicate_Live(void);
extern BOOL Indicate_Run_Get(void);

// container.c
extern void Container_Init(void);
extern void Container_Finish(void);
extern void Container_SetModuleName(char* argv0);
extern char* Container_GetModuleName(void);
extern char* Container_GetTagName(char* tagname);
extern BOOL Container_TagCreate(char* name, enum egTagDataType type, DWORD inival, char* source, char* comment);
extern BOOL Container_TagCheck(char* name);
extern void* Container_TagGetIndex(char* name);
extern void Container_Log$(const char* pServiceName, const char* pMode, const char * _Format, ...);
extern int32_t Container_EgdeMsgHandler(const char* sender, int32_t msgno, void *param);
extern BOOL Container_CreateTagsFromList(struct CONTAINER_TAGS* current);

// container.c  process exit control
extern void ExitEvent_Init(void);
extern void ExitEvent_Wait(void);
extern void ExitEvent_Post(void);
extern void ExitEvent_RtaMsgHandler(void);

