/// <summary>
/// RT-edge GbWVXeRei
/// 
///		Reiėp^OǗ@\ container.c
/// 
///	Base programming K.Machii
///
/// Copyright(C) 2025 Micronet Co. All Rights Reserved.
/// 
/// </summary>
#include <stdint.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <stdio.h>
#include "egapi.h"
#include <rt.h>
#include "EgRetain.h"

static char catalogProc[12];

/// <summary>
/// CX^XԍtvZX𐶐܂
/// tH[}bg : PLC_{1,2,c}
/// </summary>
/// <param name="instnum">CX^Xԍ</param>
BOOL Container_Set_Catalogname(RTHANDLE hRoot, char* catalogProc)
{
	int i = 1;	// CX^Xԍ

	while (TRUE)
	{
		sprintf(catalogProc, "%s_%03d", CATALOG_PROC, i);	// J^OpvZX

		// [gvZXɃJ^OĂȂꍇ
		if (LookupRtHandle(hRoot, (LPCSTR)catalogProc, NO_WAIT) == BAD_RTHANDLE)
			break;	// J^OԂ

		i++;	// CX^XԍCNg
	}

	return TRUE;
}

/// <summary>
/// GbW^Ȏ݂`FbN܂
/// </summary>
/// <param name="name"></param>
/// <returns></returns>
BOOL Container_TagCheck(char* name)
{
	int32_t		result;
	uint16_t	tagtype;
	result = EgTagGetProperty(name, "Type", &tagtype, sizeof(tagtype));
	return (result == EDGE_SUCCESS);
}

/// <summary>
/// f[^TCYoCg擾܂
/// </summary>
/// <param name=""></param>
/// <returns></returns>
uint16_t Container_TagSize(enum egTagDataType type)
{
	switch (type)
	{
	case EgVtByte:
	case EgVtBoolean:
		return 1;
	case EgVtUInt16:
	case EgVtInt16:
		return 2;
	case EgVtUInt32:
	case EgVtInt32:
		return 4;
	}
	return 0;
}

/// <summary>
/// GbW^ÕCfbNX擾܂
/// </summary>
/// <param name="name"></param>
/// <returns></returns>
void* Container_TagGetIndex(char* name)
{
	int32_t			result;
	LPEDGE_INDEX	index;
	result = EgTagGetProperty(name, "Index", &index, sizeof(index));
	return (result == EDGE_SUCCESS)?index:NULL;
}

/// <summary>
/// GbW^Ȏ݂mFāA݂ȂΏlō܂
/// </summary>
/// <param name="name"></param>
/// <param name=""></param>
/// <param name="inival"></param>
/// <param name="source"></param>
/// <param name="comment"></param>
/// <returns></returns>
BOOL Container_TagCreate(char* name, enum egTagDataType type, DWORD inival, char* source, char* comment)
{
	// GbW^Ȏ݂mF܂
	int32_t		result;
	uint16_t	size = Container_TagSize(type);
	if (!Container_TagCheck(name))
	{
		// ݂Ȃ͍쐬܂
		if (type != EgVtString)
		{
			result = EgTagCreate(name, type, size, (!source) ? "" : source, (!comment) ? "" : comment);
			if (result != EDGE_SUCCESS)
				return FALSE;
			// li[܂
			result = EgTagWrite(name, &inival, size);
			if (result != EDGE_SUCCESS)
				return FALSE;
		}
		else
		{
			// ^̏ꍇ
			char*	string = (char*)inival;
			size = 80;
			char		regname[32];
			uint16_t	islink;
			result = EgTagCreateSegment(name, type, size, (!source) ? "" : source, (!comment) ? "" : comment ,regname ,sizeof(regname) ,&islink);
			if (result != EDGE_SUCCESS)
				return FALSE;
			// li[܂
			result = EgTagWriteString(name, string);
			if (result != EDGE_SUCCESS)
				return FALSE;
		}
	}
	// ł̂Ő
	return TRUE;
}

static char _ModuleName[128];
static char _ContainerTagName[128];

/// <summary>
/// }`CX^XΉ̂߁ANT[rXԂ܂B
/// </summary>
/// <returns></returns>
char* Container_GetModuleName(void)
{
	
	return ServiceRealName;
}

/// <summary>
/// GbWReîԂ܂
/// </summary>
/// <returns></returns>
char* Container_GetTagName(char* tagname)
{
	sprintf(_ContainerTagName, "SERVICE.%s.%s", Container_GetModuleName(), tagname);
	return _ContainerTagName;
}

/// <summary>
/// ijW[(RTA)L^܂
/// </summary>
/// <param name="argv0"></param>
void Container_SetModuleName(char* argv0)
{
	// IWiobt@󂳂Ȃ悤ɃRs[܂
	size_t	size = sizeof(_ModuleName);
	strcpy_s(_ModuleName, size, argv0);
	// tH_pX̋؂蕶T
	char* delim;
	delim = strrchr(_ModuleName, '\\');
	if (delim == NULL)
		delim = strrchr(_ModuleName, '/');
	if (delim == NULL)
		return;		// 蓾ȂǈŜߎs
	delim += 1;
	size_t len = strlen(delim) + 1;
	memmove_s(_ModuleName, size, delim ,len);
	// gq'.'菜
	char* end;
	end = strrchr(_ModuleName, '.');
	if (end)
		*end = '\0';
	// _ModuleName
}

/// <summary>
/// GbWOo̓Rei̗v
/// </summary>
/// <param name="pServiceName"></param>
/// <param name="pMode"></param>
/// <param name="_Format"></param>
/// <param name=""></param>
void Container_Log$(const char* pServiceName, const char* pMode, const char * _Format, ...)
{
	va_list arg;
	static char *messBuff;
	size_t bufsize = 1024;

	// ƃobt@̃AP[gAvZXI܂free邱Ƃ͂܂
	if (!messBuff)
	{
		messBuff = (char*)malloc(bufsize);
		if (messBuff == NULL)
			return;
		memset(messBuff, 0, bufsize);
	}
	// Logo͏
	va_start(arg, _Format);
	vsprintf_s(messBuff, bufsize, _Format, arg);
	va_end(arg);
	EgFW_PrintLog(pServiceName, pMode, messBuff);
}


/// <summary>
/// vZXIp̃Cxg
/// </summary>
RTHANDLE hExitEvent;

void ExitEvent_Init(void)
{
	hExitEvent = CreateRtSemaphore(0, 1, FIFO_QUEUING);
	CatalogRtHandle(0, hExitEvent, CATALOG_EXITEVENT);
}
void ExitEvent_Wait(void)
{
	WaitForRtSemaphore(hExitEvent, 1, WAIT_FOREVER);
}
void ExitEvent_Post(void)
{
	// vZXICxgs
	ReleaseRtSemaphore(hExitEvent, 1);
}

/// <summary>
/// INtime RTAmainCxgnh
/// </summary>
void ExitEvent_RtaMsgHandler(void)
{
	EVENTINFO		eiEventInfo;

	// XbhJ^O
	CatalogRtHandle(0, GetRtThreadHandles(THIS_THREAD), CATALOG_NOTYFY);
	// INtimeVXebZ[W܂
	while (RtNotifyEvent(RT_SYSTEM_NOTIFICATIONS | RT_EXIT_NOTIFICATIONS,
		WAIT_FOREVER,
		&eiEventInfo))
	{
		switch (eiEventInfo.dwNotifyType)
		{
		case NT_HOST_DOWN:
		case TERMINATE:
			// vZXICxgs
			Indicate_Run(FALSE);
			ExitEvent_Post();
			break;
		case NT_BLUESCREEN:
			break;
		}
	}
}

/// <summary>
/// GbWt[[Np̃bZ[Wnh
/// </summary>
/// <param name="sender"></param>
/// <param name="msgno"></param>
/// <param name="param"></param>
/// <returns></returns>
int32_t Container_EgdeMsgHandler(const char* sender, int32_t msgno, void *param)
{
	switch (msgno)
	{
	case EM_SERVICE_RUN:			// T[rXJnw
		Container_Log$(ServiceRealName, EG_LOG_DBG, "EM_SERVICE_RUN recieved.");
		Indicate_Run(TRUE);
		break;
	case EM_SERVICE_PAUSE:			// T[rXꎞ~w
		Container_Log$(ServiceRealName, EG_LOG_DBG, "EM_SERVICE_PAUSE recieved.");
		Indicate_Run(FALSE);
		break;
	case EM_SERVICE_STOP:			// T[rXIw
		Container_Log$(ServiceRealName, EG_LOG_DBG, "EM_SERVICE_STOP recieved.");
		Write();
		// vZXICxgs
		Indicate_Run(FALSE);
		ExitEvent_Post();
		break;
	case EM_SERVICE_UPDATE:			// T[rXAbvf[gw
		// 
		break;
	}
	return 0;
}

/// <summary>
/// ReivZX̏
/// </summary>
void Container_Init(void)
{
	// GbWReiʏAt[[NbZ[Wnh̓o^
	EDGECONFIG		config = EDGE_CONFIG_DEFAULT;
	config.fpUserMessHdlFunc = Container_EgdeMsgHandler;
	EgInit(&config);

	// GbWReiʏAt[[N̏҂
	RtSleep(100);

	// GbWReiʏAe@\܂
	Property_Init();
	Indicate_Init();
	Trigger_Init();
	ExitEvent_Init();

	// ̃Xbh̃vCIeBZbg܂(Property_Initς܂Ă邱)
	SetRtProcessMaxPriority(0, 0);
	SetRtThreadPriority(THIS_THREAD, Property_Get_Priority() + PRI_MAIN);

	// [gvZXnh擾
	RTHANDLE hRoot = GetRtThreadHandles(ROOT_PROCESS);
	// vZX̃J^O
	Container_Set_Catalogname(hRoot, catalogProc);
	// vZXJ^O
	UncatalogRtHandle(hRoot, catalogProc);
	CatalogRtHandle(hRoot, GetRtThreadHandles(THIS_PROCESS), catalogProc);

	// XbhJ^O
	CatalogRtHandle(0, GetRtThreadHandles(THIS_THREAD), CATALOG_MAIN);

	// INtexɂINtimevZXIw߂ǗXbh
	CreateRtThread(Property_Get_Priority() + PRI_NOTIFY, ExitEvent_RtaMsgHandler, STACK_NOTIFY, 0);

}

/// <summary>
/// ReivZX̏I
/// </summary>
void Container_Finish(void)
{
	// vZXAJ^O
	RTHANDLE hRoot = GetRtThreadHandles(ROOT_PROCESS);
	UncatalogRtHandle(hRoot, catalogProc);

	// GbWReiI
	EgFinalize();
}

/// <summary>
/// ^ꂽ^OXggăGbW^O̐s܂
/// </summary>
/// <param name="current"></param>
/// <returns></returns>
BOOL Container_CreateTagsFromList(struct CONTAINER_TAGS* current)
{
	BOOL	result;
	char*	containertagname;

	// GbW^O𐶐܂
	while (current->name)
	{
		// ^OgݗĂ܂
		containertagname = Container_GetTagName(current->name);
		// ^Ȏ݂mF܂
		if (Container_TagCheck(containertagname))
		{
			// ݂̂ŃCfbNX擾Ă܂
			current->index = Container_TagGetIndex(containertagname);
		}
		else if (current->create)
		{
			// ݂ȂɃ^O𐶐܂
			result = Container_TagCreate(containertagname, current->type, current->defaultval, current->source, current->comment);
			if (!result)
				return FALSE;
			// CfbNX擾Ă܂
			current->index = Container_TagGetIndex(containertagname);
		}

		current++;
	}

	return FALSE;
}