/// <summary>
/// RT-edge GbWVXeRei
/// 
///		CWP[^^O@\ indicate.c
/// 
///	Base programming K.Machii
///
/// Copyright(C) 2025 Micronet Co. All Rights Reserved.
/// 
/// </summary>
#include <stdint.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <stdio.h>
#include "egapi.h"
#include <rt.h>
#include "EgRetain.h"


/// <summary>
/// GbW^O̒`
/// </summary>
struct CONTAINER_TAGS		indicate[] =
{
	{"Status"		,EgVtByte		,0	,TRUE	},
	{"Error"		,EgVtBoolean	,0	,TRUE	},
	{"Run"			,EgVtBoolean	,1	,TRUE	},
	{"Live"			,EgVtUInt32		,0	,TRUE	},
	{"SaveCount"	,EgVtUInt32		,0	,TRUE	},
	{"LoadCount"	,EgVtUInt32		,0	,TRUE	},
	{0}
};


void Indicate_Status(BYTE statuscode)
{
	int32_t		result;
	LPEDGE_INDEX	Tag = indicate[0].index;
	result = EgTagWriteByIndex(Tag, &statuscode, sizeof(statuscode));
}

void Indicate_Error(BOOL error)
{
	int32_t		result;
	LPEDGE_INDEX	Tag = indicate[1].index;
	result = EgTagWriteByIndex(Tag, &error, sizeof(errno));
}

void Indicate_Run(BOOL running)
{
	int32_t		result;
	LPEDGE_INDEX	Tag = indicate[2].index;
	result = EgTagWriteByIndex(Tag, &running, sizeof(running));
}

BOOL Indicate_Run_Get(void)
{
	int32_t		result;
	BOOL		running = FALSE;
	LPEDGE_INDEX	Tag = indicate[2].index;
	result = EgTagReadByIndex(Tag, &running, sizeof(running));
	return running;
}

void Indicate_Live(void)
{
	// CNg܂
	static uint32_t	live;
	int32_t		result;
	live++;
	LPEDGE_INDEX	Tag = indicate[3].index;
	result = EgTagWriteByIndex(Tag, &live, sizeof(live));
}

void Indicate_SaveCount(void)
{
	// CNg܂
	static uint32_t	count;
	int32_t		result;
	count++;
	LPEDGE_INDEX	Tag = indicate[4].index;
	result = EgTagWriteByIndex(Tag, &count, sizeof(count));
}

void Indicate_LoadCount(void)
{
	// CNg܂
	static uint32_t	count;
	int32_t		result;
	count++;
	LPEDGE_INDEX	Tag = indicate[5].index;
	result = EgTagWriteByIndex(Tag, &count, sizeof(count));
}

/// <summary>
/// CWP[^@\܂
/// </summary>
/// <returns></returns>
BOOL Indicate_Init(void)
{
	// ^OXg^ăGbW^O𐶐܂
	BOOL result;
	result = Container_CreateTagsFromList(indicate);
	return result;
}
