/* MD5.H - header file for MD5C.C
 *
 * $Id: md5.h,v 1.2 2001/12/06 16:28:24 bporter Exp $
 */

 /* Copyright (C) 1991-2, RSA Data Security, Inc. Created 1991. All
 rights reserved.

 License to copy and use this software is granted provided that it
 is identified as the "RSA Data Security, Inc. MD5 Message-Digest
 Algorithm" in all material mentioning or referencing this software
 or this function.

 License is also granted to make and use derivative works provided
 that such works are identified as "derived from the RSA Data
 Security, Inc. MD5 Message-Digest Algorithm" in all material
 mentioning or referencing the derived work.

 RSA Data Security, Inc. makes no representations concerning either
 the merchantability of this software or the suitability of this
 software for any particular purpose. It is provided "as is"
 without express or implied warranty of any kind.

 These notices must be retained in any copies of any part of this
 documentation and/or software.
  */

#ifndef _h_MD5
#define _h_MD5 1

#ifndef UINT4
#define UINT4 unsigned long
#endif

#ifndef POINTER
#define POINTER unsigned char *
#endif

  /* MD5 context. */
typedef struct {
	UINT4 state[4];                                   /* state (ABCD) */
	UINT4 count[2];        /* number of bits, modulo 2^64 (lsb first) */
	unsigned char buffer[64];                         /* input buffer */
} MD5_CONTEXT;

extern void MD5Init(MD5_CONTEXT *);
extern void MD5Update(MD5_CONTEXT *, unsigned char *, unsigned int);
extern void MD5Final(unsigned char[16], MD5_CONTEXT *);
//extern unsigned char *MD5Final (MD5_CONTEXT *);

#endif /* _h_MD5 */
