/// <summary>
/// RT-edge GbWVXeRei
/// 
///		vpeB^O@\ property.c
/// 
///	Base programming K.Machii
///
/// Copyright(C) 2025 Micronet Co. All Rights Reserved.
/// 
/// </summary>
#include <stdint.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <stdio.h>
#include "egAPI.h"
#include <rt.h>
#include "EgRetain.h"


BOOL    bAutorun = FALSE;	// eC s
BYTE	bBasePriority = 0;		// eC x[XvCIeB
DWORD	dwInterval = 0;		// eC C^[o
BOOL    bBackup = FALSE;	// eC obNAbvtO
char	OutPath[128] = { 0 };		// eC t@Co͐pX

/// <summary>
/// GbW^O̒`
/// </summary>
struct CONTAINER_TAGS		property[] =
{
	{"AutoRun"	,EgVtBoolean	,FALSE						,TRUE	,Property_Process_Autorun},
	{"Priority"	,EgVtUInt32		,PRI_DEF_BASE				,TRUE	,Property_Process_Priority},
	{"Interval"	,EgVtUInt32		,INTERVAL_DEF				,TRUE	,Property_Process_Interval},
	{"UseBackup",EgVtBoolean	,FALSE						,TRUE	,Property_Process_Backup},
	{"OutPath"	,EgVtString		,(DWORD)OUTPATH_DEF			,TRUE	,Property_Process_Outpath},
	{0}
};


// ȉsetter
void Property_Process_Autorun(struct CONTAINER_TAGS* my)
{
	char* Tag;
	int32_t		result;
	int32_t		value;
	Tag = Container_GetTagName(my->name);
	result = EgTagRead(Tag, &value, sizeof(value));
	if (result == EDGE_SUCCESS)
		bAutorun = value;
}

void Property_Process_Priority(struct CONTAINER_TAGS* my)
{
	char* Tag;
	int32_t		result;
	int32_t		value;
	Tag = Container_GetTagName(my->name);
	result = EgTagRead(Tag, &value, sizeof(value));
	if (result == EDGE_SUCCESS)
		bBasePriority = value;
}

void Property_Process_Interval(struct CONTAINER_TAGS* my)
{
	char* Tag;
	int32_t		result;
	int32_t		value;
	Tag = Container_GetTagName(my->name);
	result = EgTagRead(Tag, &value, sizeof(value));
	if (result == EDGE_SUCCESS)
		dwInterval = value;
}

void Property_Process_Backup(struct CONTAINER_TAGS* my)
{
	char* Tag;
	int32_t		result;
	int32_t		value;
	Tag = Container_GetTagName(my->name);
	result = EgTagRead(Tag, &value, sizeof(value));
	if (result == EDGE_SUCCESS)
		bBackup = value;
}

void Property_Process_Outpath(struct CONTAINER_TAGS* my)
{
	char* Tag;
	int32_t		result;
	char		value[128];

	Tag = Container_GetTagName(my->name);
	result = EgTagReadString(Tag, value, sizeof(value));
	if (result == EDGE_SUCCESS)
		sprintf(OutPath, "%s", value);
}

// ȉgetter
BOOL Property_Get_Autorun(void)
{
	int32_t		result;
	uint32_t	value = 0;
	LPEDGE_INDEX	Tag = property[0].index;
	result = EgTagReadByIndex(Tag, &value, sizeof(value));
	return value;
}

uint32_t Property_Get_Priority(void)
{
	int32_t		result;
	uint32_t	value = 0;
	LPEDGE_INDEX	Tag = property[1].index;
	result = EgTagReadByIndex(Tag, &value, sizeof(value));
	return value;
}

uint32_t Property_Get_Interval(void)
{
	int32_t		result;
	uint32_t	value = 0;
	LPEDGE_INDEX	Tag = property[2].index;
	result = EgTagReadByIndex(Tag, &value, sizeof(value));
	return value;
}

BOOL Property_Usebackup_Get(void)
{
	int32_t		result;
	BOOL		value = 0;
	LPEDGE_INDEX	Tag = property[3].index;
	result = EgTagReadByIndex(Tag, &value, sizeof(value));
	return value;
}

char* Property_Outpath_Get(void)
{
	int32_t			result;
	static char		value[128];
	char*	Tag = Container_GetTagName(property[4].name);
	result = EgTagReadString(Tag, value, sizeof(value));
	return value;
}


/// <summary>
/// vpeB@\܂
/// </summary>
/// <returns></returns>
BOOL Property_Init(void)
{
	// ^OXg^ăGbW^O𐶐܂
	BOOL result;
	result = Container_CreateTagsFromList(property);
	return result;
}