/// <summary>
/// RT-edge GbWVXeRei
/// 
///		eCt@C̊Ǘ retainfile.c
/// 
///	Base programming K.Machii
///
/// Copyright(C) 2025 Micronet Co. All Rights Reserved.
/// 
/// </summary>
#include <stdint.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <stdio.h>
#include "egapi.h"

#include "EgRetain.h"


/// <summary>
/// eCt@C̃pX擾܂
/// </summary>
char	_RetainFilePath[128];
char	_RetainBackPath[128];
char* RetainFile_GetPath(void)
{
	return _RetainFilePath;
}

/// <summary>
/// eCobNAbvt@C̃pX擾܂
/// </summary>
/// <returns></returns>
char* RetainFile_BackupGetPath(void)
{
	return _RetainBackPath;
}

/// <summary>
/// eCt@C@\܂
/// </summary>
void RetainFile_Init(void)
{
	char*		path;
	// eCt@CpX
	path = Property_Outpath_Get();
	strcpy_s(_RetainFilePath, sizeof(_RetainFilePath), path);
	strcat_s(_RetainFilePath, sizeof(_RetainFilePath), FILENAME_RETAIN);

	printf("filepath=%s\n", _RetainFilePath);

	// eCt@CobNAbvpX
	path = Property_Outpath_Get();
	strcpy_s(_RetainBackPath, sizeof(_RetainBackPath), path);
	strcat_s(_RetainBackPath, sizeof(_RetainBackPath), FILENAME_BACKUP);

	// eCΏۃ^ÕXgnbVR[hvZ܂ (1)
	DWORD		currenthash;
	currenthash = RetainFile_HashCalc();

	// eCt@C̃nbVR[h[h܂ (2)
	DWORD		filehash;
	filehash = RetainFile_HashRead();

	// eCt@CƃnbVR[hƈvȂ (1)(2)
	if (currenthash != filehash)
	{
		// OFeCt@C`ɑ΂ĕsȂ̂ō폜܂
		Container_Log$(ServiceRealName, EG_LOG_WRN, "Retained file hash code does not match and will be deleted.");
		Container_Log$(ServiceRealName, EG_LOG_WRN, "current hash code = %x", currenthash);
		Container_Log$(ServiceRealName, EG_LOG_WRN, "file hash code    = %x", filehash);

		// eCΏۃ^OɕύXAnbVlقȂꍇ́A
		// ȃeCt@CȂ̂ŕKvȃobNAbv̂̂폜܂
		BOOL		dobackup;
		dobackup = Property_Usebackup_Get();
		if (dobackup)
		{
			// ݂̃eCt@C͖Ȃ̂ŃobNAbvt@Cɉč폜܂
			RetainFile_BackupSwap();
		}
		else
		{
			// ݂̃eCt@C͖Ȃ̂ō폜܂
			RetainFile_Remove();
		}
	}

}

/// <summary>
/// eCt@C폜܂
/// </summary>
void RetainFile_Remove(void)
{
	char*		org;
	org = RetainFile_GetPath();
	// eCt@C폜
	remove(org);
}

/// <summary>
/// eCt@C̃obNAbv܂
/// </summary>
void RetainFile_BackupSwap(void)
{
	char*		org, *bak;
	org = RetainFile_GetPath();
	bak = RetainFile_BackupGetPath();
	// obNAbvt@C폜
	remove(bak);
	// ݂̃eCt@CobNAbvt@Cɉ܂
	// eCt@C݂͑ȂȂ܂
	rename(org, bak);
}

/// <summary>
/// nbVl
/// </summary>
#include "md5.h"
typedef union tHashCode
{
	struct {
		DWORD		code1;					// 1nbVR[h(32bit) CfbNXp
		DWORD		code2;					// 2nbVR[h(32bit) CfbNXp
		DWORD		code3;					// 3nbVR[h(32bit) CfbNXp
		DWORD		code4;					// 4nbVR[h(32bit) Փ˃`FbNp
	};
	BYTE		code[16];					// nbVR[h(16byte)
}HASHCODE;

/// <summary>
/// 񂩂nbVR[h̎擾
/// </summary>
/// <param name="cmdname"></param>
/// <returns></returns>
HASHCODE _Hash(const char *name)
{
	MD5_CONTEXT		hMd5;
	HASHCODE		hash;
	MD5Init(&hMd5);
	MD5Update(&hMd5, (unsigned char*)name, (unsigned int)strlen(name));
	MD5Final(hash.code, &hMd5);
	return hash;
}

/// <summary>
/// ̃eCt@C`ɋL^ĂnbVR[hǂݍ݂܂
/// </summary>
/// <returns></returns>
DWORD RetainFile_HashRead(void)
{
	static DWORD		filehash;

	char*		filepath;
	FILE*		retain;
	// eCt@CJ܂
	filepath = RetainFile_GetPath();
	retain = fopen(filepath, "rb");
	if (retain == NULL)
		return filehash;

	// eCt@C`̃nbVR[h32bitǂݍ݂܂
	fread(&filehash, sizeof(HASHCODE), 1, retain);

	// nbVt@C܂
	fclose(retain);


	// nbVR[hԋp܂
	return filehash;
}

/// <summary>
/// eCΏۃ^ÕXgnbVR[h32bitvZ܂
/// </summary>
/// <returns>nbVR[h(O[oϐ: EgRetain.hɒ`)</returns>
DWORD RetainFile_HashCalc(void)
{
	// ŏ̃R[nbVR[hvZ܂
	if (hashcode == 0)
	{
		int			count = egTagRefs_IN_Count;
		EGTAGREF*	tags = egTagRefs_IN;
		int			lp1;

		// TagRef_INQƂănbVR[h𐶐܂
		for (lp1 = 0; lp1 < count; lp1++, tags++)
		{
			// O܂ł̉ZʂPrbg[e[g
			//iTagRefяvZʂɔf悤ɏ܂j
			hashcode = (hashcode << 1) | (hashcode >> 31);
			// Z
			hashcode += _Hash(tags->Name).code1;
		}
	}

	// nbVR[hԋp܂
	return hashcode;
}
