/// <summary>
/// RT-edge GbWVXeRei
/// 
///		gK^O@\ trigger.c
/// 
///	Base programming K.Machii
///
/// Copyright(C) 2025 Micronet Co. All Rights Reserved.
/// 
/// </summary>
#include <stdint.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <stdio.h>
#include <rt.h>
#include "egapi.h"

#include "EgRetain.h"


/// <summary>
/// GbW^O̒`
/// </summary>
struct CONTAINER_TAGS		trigger[] =
{
	{"Save"		,EgVtUInt32		,0	,TRUE	},
	{"Load"		,EgVtUInt32		,0	,TRUE	},
	{0}
};

/// <summary>
/// gK^O̊ǗpCX^X\
/// </summary>
typedef struct _TRIGTAG
{
	LPEDGE_INDEX	TagIndex;
	uint32_t		reservedvalue;
} *TRIGTAG;

/// <summary>
/// wGbW^OŃgK^OJn܂
/// </summary>
/// <param name="TagIndex"></param>
/// <returns>gK^OCX^XԂ</returns>
TRIGTAG Trigger_TagInit(LPEDGE_INDEX TagIndex)
{
	int32_t		result;
	TRIGTAG		ttag = (TRIGTAG)malloc(sizeof(struct _TRIGTAG));
	// AgK̓[NAĂ܂
	ttag->TagIndex = TagIndex;
	ttag->reservedvalue = 0;
	result = EgTagWriteByIndex(ttag->TagIndex, &ttag->reservedvalue, sizeof(ttag->reservedvalue));
	// gK^OǗp̃CX^XԂ܂(q[v)
	return ttag;
}

/// <summary>
/// gK^OI܂
/// </summary>
/// <param name="ttag"></param>
void Trigger_TagClear(TRIGTAG ttag)
{
	if( ttag )
		free(ttag);
}

/// <summary>
/// gK^O̕ωigKj𔻒肵܂
/// </summary>
/// <param name="ttag"></param>
/// <returns></returns>
BOOL Trigger_TagCheck(TRIGTAG ttag)
{
	int32_t			result;
	uint32_t		prevalue = ttag->reservedvalue;
	BOOL			triggered;
	// ݒlǂݍ݂܂
	result = EgTagReadByIndex(ttag->TagIndex, &ttag->reservedvalue, sizeof(ttag->reservedvalue));
	// gK𔻒肵܂iOlƂ̔rj
	triggered = (prevalue != ttag->reservedvalue);
	// ߂l
	return triggered;
}

/// <summary>
/// gK̃CxgIƂA[ɏ߂ƂŊʒB܂
/// </summary>
/// <param name="ttag"></param>
void Trigger_TagFinished(TRIGTAG ttag)
{
	int32_t			result;
	// l邱Ƃŏ݊ʒB܂
	ttag->reservedvalue = 0;
	result = EgTagWriteByIndex(ttag->TagIndex, &ttag->reservedvalue, sizeof(ttag->reservedvalue));
}

/// <summary>
/// gK̃Xbh
/// 
///		"SERVICE.EgRetain.Save"		eC݁B0ȊO̒lނƃgKBI0ɏ܂
///		"SERVICE.EgRetain.Load"		eCǂݍ݁B0ȊO̒lނƃgKBI0ɏ܂
/// 
/// </summary>
void Trigger_DetectThread(void)
{
	// gK^ÕCfbNXZoĈȌ̃ANZX܂
	LPEDGE_INDEX	SaveTag_index = trigger[0].index;
	LPEDGE_INDEX	LoadTag_index = trigger[1].index;

	// gK^OCX^X𐶐(q[vgp)ă[NA܂
	TRIGTAG	save = Trigger_TagInit(SaveTag_index);
	TRIGTAG	load = Trigger_TagInit(LoadTag_index);

	// XbhJ^O
	CatalogRtHandle(0, GetRtThreadHandles(THIS_THREAD), CATALOG_TRIG);

	// gK܂
	BOOL			savetrig;
	BOOL			loadtrig;
	BOOL			result;
	while (1)
	{
		// C^[oœ삵܂
		RtSleepEx(100);

		// ReiғԂŖȂ炱̃XbhsȂ
		if (!Indicate_Run_Get())
			continue;

		// LiveCWP[^XViĂIj
		Indicate_Live();

		// gK𔻒肵AeCۑ̃NGXgƒf肵
		savetrig = Trigger_TagCheck(save);
		if (savetrig)
		{
			// eCݏJn܂
			result = Write();

			// l邱Ƃŏ݊ʒB܂
			Trigger_TagFinished(save);

			// ۑ񐔂̃CNg
			if(result)a
				Indicate_SaveCount();
		}

		// gK𔻒肵AeCǂݍ݂̃NGXgƒf肵
		loadtrig = Trigger_TagCheck(load);
		if (loadtrig)
		{
			// eCǂݍݏJn܂
			result = Read();

			// l邱Ƃœǂݍ݊ʒB܂
			Trigger_TagFinished(load);

			// ǂݍ݉񐔂̃CNg
			if(result)
				Indicate_LoadCount();
		}
	}

	// gK^OCX^X܂
	Trigger_TagClear(save);
	Trigger_TagClear(load);
}

/// <summary>
/// gK@\܂
/// </summary>
/// <returns></returns>
BOOL Trigger_Init(void)
{
	// ^OXg^ăGbW^O𐶐܂
	BOOL result;
	result = Container_CreateTagsFromList(trigger);

	// gKXbh𐶐܂
	CreateRtThread( Property_Get_Priority() + PRI_TRIG, Trigger_DetectThread, STACK_TRIG, 0);

	return result;
}